/*
* Author: Chris Campbell - www.iforce2d.net
*
* See usage details at http://www.iforce2d.net/cc2dxres/otf
*
* This software is provided 'as-is', without any express or implied warranty.
* In no event will the authors be held liable for any damages arising from
* the use of this software. Permission is granted to anyone to use this software
* for any purpose, including commercial applications, and to alter it and
* redistribute it freely.
*
*/
#ifndef OTFLAYER_H
#define OTFLAYER_H

#include <cocos2d.h>
#include <network/HttpClient.h>

class OTFLayer : public cocos2d::CCLayer
{
    bool m_otfUpdateInProgress;
    bool m_requestInProgress;
    std::vector< std::pair< std::string, std::string > > m_urlsToCheck;
    std::pair< std::string, std::string > m_currentUrl;
    int m_otfSkippedCount;
    int m_otfFetchedCount;
    unsigned char* m_md5Buffer;

public:
    OTFLayer();
    ~OTFLayer();

    static cocos2d::CCScene* scene();
    CREATE_FUNC(OTFLayer);
    virtual bool init();

    virtual void update(float delta);
    void onTouchesBegan(const std::vector<cocos2d::Touch*>& touches, cocos2d::Event *unused_event);

    void startHttpGET(std::string url);
    std::string getHashForFile( std::string filename );
    void handleManifest( cocos2d::network::HttpResponse* response );
    void handleResourceFile( cocos2d::network::HttpResponse* response );
    void onRequestCompleted( cocos2d::network::HttpClient* client, cocos2d::network::HttpResponse* response);
    void updateOTFContent();
    void otfTick();
};

#endif // OTFLAYER_H
